=== modified file 'bzrlib/chunk_writer.py'
--- bzrlib/chunk_writer.py	2008-08-22 05:40:12 +0000
+++ bzrlib/chunk_writer.py	2008-08-22 05:54:44 +0000
@@ -177,7 +177,11 @@
             if out:
                 self.bytes_list.append(out)
                 self.bytes_out_len += len(out)
-            if self.bytes_out_len + 10 <= capacity:
+
+            # We are a bit extra conservative, because it seems that you *can*
+            # get better compression with Z_SYNC_FLUSH than a full compress. It
+            # is probably very rare, but we were able to trigger it.
+            if self.bytes_out_len + 100 <= capacity:
                 # It fit, so mark it added
                 self.bytes_in.append(bytes)
                 self.seen_bytes += len(bytes)

=== modified file 'bzrlib/tests/test_chunk_writer.py'
--- bzrlib/tests/test_chunk_writer.py	2008-08-22 05:40:12 +0000
+++ bzrlib/tests/test_chunk_writer.py	2008-08-22 05:54:44 +0000
@@ -59,10 +59,8 @@
             lines.append(''.join(map(str, numbers)) + '\n')
         writer = chunk_writer.ChunkWriter(4096)
         for idx, line in enumerate(lines):
-            if idx >= 45:
-                import pdb; pdb.set_trace()
             if writer.write(line):
-                self.assertEqual(47, idx)
+                self.assertEqual(46, idx)
                 break
         bytes_list, unused, _ = writer.finish()
         node_bytes = self.check_chunk(bytes_list, 4096)

